
			ASSUME esi:PTR XMLParser

; 
; eax - character input

XML_XMLCommandProc	PROC USES edi lpString:DWORD

			mov	edi,lpString
			clc

			ret
XML_XMLCommandProc	ENDP

; 
;
;  Reads the next character from the XMLParser.lpXMLstream string and converts into unicode
;  character.
;  - If there are not datato read returns CF=1, eax=0.
;  If the input character could not be converted returns CF=1, eax=character code.
;
;  IN:	esi - lpXMLParser
;	edi - lpXMLStream
;
; OUT:	eax - UNICODE character
;	edi - lpXMLStream
;
; 

XML_ReadChar		PROC USES ebx

			mov	eax,[esi].encoding
			or	eax,eax				; is the encoding determined?
			jnz @10
; 
; determine encoding
			mov	ebx,[edi]
			mov	eax,ENCODING_UTF16_LSB
			cmp	bx,0FEFFh
			jnz @01
			add	edi,2				; skip the byte order mark
			jmp @05
@01:
			or	bh,bh
			jz @05

			mov	eax,ENCODING_UTF16_MSB
			cmp	bx,0FFFEh
			jnz @02
			add	edi,2				; skip the byte order mark
			jmp @05
@02:
			or	bl,bl
			jz @05

			mov	eax,ENCODING_UTF8
@05:
			mov	[esi].encoding,eax
; 
; Read char
@10:
			cmp	eax,ENCODING_UTF8
			jnz @11
			xor	eax,eax
			mov	al,[edi]
			add	edi,1
			jmp @2
@11:
			cmp	eax,ENCODING_UTF16_LSB
			jnz @12
			xor	eax,eax
			mov	al,[edi]
			mov	ah,[edi+1]
			add	edi,2
			jmp @2
@12:
			cmp	eax,ENCODING_UTF16_MSB
			jnz @13
			xor	eax,eax
			mov	ah,[edi]
			mov	al,[edi+1]
			add	edi,2
			jmp @2
@13:
			mov	[esi].dwErrorCode,XML_ENCODING_NOT_SUPPORTED
			stc
			jmp @3
@2:
			mov	[esi].lpXMLstream,edi
@21:
			cmp	eax,0Ah
			jnz @22
			mov	[esi].dwCurrentCol,1
			add	[esi].dwCurrentRow,1
@22:
			cmp	eax,0Dh					; change CR
			jnz @23
			mov	eax,0Ah					; into NewLine
@23:
			clc
@3:

			ret

XML_ReadChar		ENDP

; 
; eax - parameter (input)

XML_OpenTagStart	PROC

		; max depth of tags reached?
			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentLevel
			cmp	ebx,XML_MAX_DEPTH_OF_TAGS
			jc @1
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_INTERNAL_ERROR
				stc
				jmp @3
@1:
		; reset auxillary string and store 1 char
			mov	edi,[esi-XMLParser.charParserEFSM].lpAuxString
			mov	[edi],ax
			add	edi,2
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi

			clc
@3:
			ret

XML_OpenTagStart	ENDP

; 
; eax - parameter (input)

XML_OpenTag		PROC

			mov	edi,[esi-XMLParser.charParserEFSM].lpChar
			mov	[edi],ax			; store char input
			add	[esi-XMLParser.charParserEFSM].lpChar,2
			clc
			ret

XML_OpenTag		ENDP

; 
; eax - parameter (input)

XML_OpenTagName	PROC

			mov	ecx,[esi-XMLParser.charParserEFSM].lpChar			; end of tag name
			mov	edi,[esi-XMLParser.charParserEFSM].lpAuxString		; start of tag name
			sub	ecx,edi							; string length in bytes
			add	ecx,2							; space for EOS char

			push	ecx
			invoke GlobalAlloc,GPTR,ecx						; allocate string
			pop	ecx
			or	eax,eax
			jnz @1
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_INTERNAL_ERROR
				stc
				jmp @3
@1:
			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentLevel
			mov	[esi+ebx*4-XMLParser.charParserEFSM].lpTags,eax
			mov	ebx,eax							; address of allocated string
			sub	ecx,4
@2:
		; store tag
			mov	ax,[edi+ecx]
			mov	[ebx+ecx],ax
			sub	ecx,2
			jnc @2
			clc
@3:
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi
			ret

XML_OpenTagName	ENDP

; 
; eax - parameter (input)

XML_EmptyTag		PROC

			push	esi
			call XML_OpenTagEnd
			pop	esi
			jc @1
			call XML_CloseTagEnd
@1:
			ret

XML_EmptyTag		ENDP

; 
; eax - parameter (input)

XML_OpenTagEndAtOnce	PROC

			push	esi
			call XML_OpenTagName
			pop	esi
			jc @1
			call XML_OpenTagEnd
@1:
			ret

XML_OpenTagEndAtOnce	ENDP

; 
; eax - parameter (input)

XML_OpenTagEnd		PROC

		; call handler
			mov	eax,[esi-XMLParser.charParserEFSM].lpStartTagHandler
			or	eax,eax
			jz @21
			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentLevel
			lea	edx,[esi-XMLParser.charParserEFSM].lpAttribs
			push	edx
			push	[esi+ebx*4-XMLParser.charParserEFSM].lpTags
			call DWORD PTR eax
			cmp	eax,1					; handler returns bool
			jc @3
@21:
			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentAttrib
			or	ebx,ebx
			jz @24
			sub	ebx,1
@22:
			mov	eax,[esi+ebx*8-XMLParser.charParserEFSM].lpAttribs
			invoke GlobalFree,eax
			or	eax,eax
			jnz @221
			mov	[esi+ebx*8-XMLParser.charParserEFSM].lpAttribs,eax
			mov	eax,[esi+ebx*8-XMLParser.charParserEFSM+4].lpAttribs
			invoke GlobalFree,eax
			or	eax,eax
			jz @23
@221:
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_INTERNAL_ERROR
				stc
				jmp @3
@23:
			mov	[esi+ebx*8-XMLParser.charParserEFSM+4].lpAttribs,eax
			sub	ebx,1
			jnc @22
@24:
			mov	[esi-XMLParser.charParserEFSM].dwCurrentAttrib,0
			add	[esi-XMLParser.charParserEFSM].dwCurrentLevel,1		; increase depth level
			clc
@3:
			ret

XML_OpenTagEnd		ENDP

; 
; eax - parameter (input)

XML_AttribName		PROC

			mov	edi,[esi-XMLParser.charParserEFSM].lpChar
			mov	[edi],ax
			add	[esi-XMLParser.charParserEFSM].lpChar,2
			clc

			ret
XML_AttribName		ENDP
; 
; eax - parameter (input)

XML_AttribNameEnd	PROC

			mov	ecx,[esi-XMLParser.charParserEFSM].lpChar
			mov	edi,[esi-XMLParser.charParserEFSM].lpAuxString
			sub	ecx,edi
			add	ecx,2

			push	ecx
			invoke GlobalAlloc,GPTR,ecx
			pop	ecx
			or	eax,eax
			jnz @1
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_INTERNAL_ERROR
				stc
				jmp @3
@1:
			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentAttrib
			mov	[esi+ebx*8-XMLParser.charParserEFSM].lpAttribs,eax
			mov	ebx,eax				; address of allocated string

			sub	ecx,4
@2:
		; store attrib name
			mov	ax,[edi+ecx]
			mov	[ebx+ecx],ax
			sub	ecx,2
			jnc @2
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi
			clc
@3:
			ret
XML_AttribNameEnd	ENDP

; 
; eax - parameter (input)

XML_AttribValue		PROC

			mov	edi,[esi-XMLParser.charParserEFSM].lpChar
			mov	[edi],ax
			add	[esi-XMLParser.charParserEFSM].lpChar,2
			clc

			ret
XML_AttribValue		ENDP
; 
; eax - parameter (input)

XML_AttribValueEnd	PROC

			mov	ecx,[esi-XMLParser.charParserEFSM].lpChar
			mov	edi,[esi-XMLParser.charParserEFSM].lpAuxString
			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentAttrib
			sub	ecx,edi				; empty attrib value?
			jnz @0
				
				mov	[esi+ebx*8-XMLParser.charParserEFSM+4].lpAttribs,ecx
				jmp @25
@0:
			add	ecx,2

			push	ecx
			invoke GlobalAlloc,GPTR,ecx
			pop	ecx
			or	eax,eax
			jnz @1
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_INTERNAL_ERROR
				stc
				jmp @3
@1:
			mov	[esi+ebx*8-XMLParser.charParserEFSM+4].lpAttribs,eax
			mov	ebx,eax				; address of allocated string
			sub	ecx,4
@2:
		; store attrib value
			mov	ax,[edi+ecx]
			mov	[ebx+ecx],ax
			sub	ecx,2
			jnc @2
@25:
			add	[esi-XMLParser.charParserEFSM].dwCurrentAttrib,1
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi
			clc
@3:
			ret
XML_AttribValueEnd	ENDP

; 
; eax - parameter (input)

XML_CDataStart		PROC

			mov	edi,[esi-XMLParser.charParserEFSM].lpAuxString
			mov	[edi],ax
			add	edi,2
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi
			clc
			ret

XML_CDataStart		ENDP

; 
; eax - parameter (input)

XML_CData		PROC

			mov	ecx,[esi-XMLParser.charParserEFSM].lpAuxStringEnd
			mov	edi,[esi-XMLParser.charParserEFSM].lpChar
			mov	[edi],ax
			cmp	edi,ecx
			jnz @2
			mov	ebx,[esi-XMLParser.charParserEFSM].lpAuxString
			sub	ecx,ebx						; size of auxString
			push	ecx
			shl	ecx,1						; new size is the double size
			mov	[esi-XMLParser.charParserEFSM].lpAuxStringEnd,ecx
			invoke GlobalAlloc,GPTR,ecx
			add	[esi-XMLParser.charParserEFSM].lpAuxStringEnd,eax	; new end of auxString
			mov	[esi-XMLParser.charParserEFSM].lpChar,eax
			pop	ecx
			add	[esi-XMLParser.charParserEFSM].lpChar,ecx
			mov	edi,eax
@1:
			mov	ax,[ebx+ecx]					; copy old auxString into new one
			mov	[edi+ecx],ax
			sub	ecx,2
			jnc @1
			invoke GlobalFree,ebx
			mov	[esi-XMLParser.charParserEFSM].lpAuxString,edi	; new auxString
@2:
			add	[esi-XMLParser.charParserEFSM].lpChar,2
			clc
			ret

XML_CData		ENDP

; 
; eax - parameter (input)

XML_CDataEnd		PROC

			mov	ecx,[esi-XMLParser.charParserEFSM].lpChar
			mov	edi,[esi-XMLParser.charParserEFSM].lpAuxString
			mov	WORD PTR [ecx],0
			
			mov	eax,[esi-XMLParser.charParserEFSM].lpCDATAHandler
			or	eax,eax
			clc
			jz @1
			push	[esi-XMLParser.charParserEFSM].lpAuxString
			call DWORD PTR eax
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi
			cmp	eax,1
@1:
			ret

XML_CDataEnd		ENDP

; 
; eax - parameter (input)

XML_CloseTagStart	PROC

		; depth of tags is zero?
			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentLevel
			sub	ebx,1
			jnc @1
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_PARSE_ERROR
				stc
				jmp @3
@1:
			mov	edi,[esi+ebx*4-XMLParser.charParserEFSM].lpTags		; get last stored tag string
			cmp	ax,[edi]				; character match?
			jz @2
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_TAGS_DONT_MATCH
				stc
				jmp @3
@2:
			add	edi,2
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi			; points to next char of stored tag
			clc
@3:
			ret

XML_CloseTagStart	ENDP

; 
; eax - parameter (input)

XML_CloseTag		PROC

			xor	ebx,ebx
			mov	edi,[esi-XMLParser.charParserEFSM].lpChar			; get pointer to next char of stored tag
			mov	bx,[edi]				; end of tag string?
			or	ebx,ebx
			jz @11
			cmp	eax,ebx				; character match?
			jz @2
@11:
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_TAGS_DONT_MATCH
				stc
				jmp @3
@2:
			add	edi,2
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi			; points to next char of stored tag
			clc
@3:
			ret

XML_CloseTag		ENDP

; 
; eax - parameter (input)

XML_CloseTagEnd		PROC

			mov	ebx,[esi-XMLParser.charParserEFSM].dwCurrentLevel
			lea	edi,[esi+ebx*4-4-XMLParser.charParserEFSM].lpTags		; pointer of last stored tag
		; call handler
			mov	eax,[esi-XMLParser.charParserEFSM].lpEndTagHandler
			mov	ebx,[edi]
			or	eax,eax
			jz @1
			push	ebx
			call DWORD PTR eax
			cmp	eax,1
			jc @2
@1:
			invoke GlobalFree,ebx			; free tag name string
			or	eax,eax
			jz @11
				mov	[esi-XMLParser.charParserEFSM].dwErrorCode,XML_INTERNAL_ERROR
				stc
				jmp @2
@11:
			sub	[esi-XMLParser.charParserEFSM].dwCurrentLevel,1		; decrease depth level
			mov	[edi],eax
			clc
@2:
			ret

XML_CloseTagEnd		ENDP

; 
XML_CommandNameStart	PROC

			mov	eax,[esi-XMLParser.charParserEFSM].lpAuxString
			mov	[esi-XMLParser.charParserEFSM].lpChar,eax
			clc
			ret

XML_CommandNameStart	ENDP

; 
XML_CommandName	PROC

			mov	edi,[esi-XMLParser.charParserEFSM].lpChar
			mov	[edi],ax
			add	[esi-XMLParser.charParserEFSM].lpChar,2
			clc
			ret

XML_CommandName	ENDP

; 
XML_CommandNameEnd	PROC

			mov	ecx,[esi-XMLParser.charParserEFSM].lpChar
			mov	edi,[esi-XMLParser.charParserEFSM].lpAuxString
			mov	WORD PTR [ecx],0
			
@1:
			mov	eax,[edi]
			or	eax,00200020h				; convert to lowercase
			cmp	eax,DWORD PTR [XML_COMMAND_NAME]
			jnz @2
			mov	eax,[edi+4]
			or	eax,00000020h				; convert to lowercase
			cmp	eax,DWORD PTR [XML_COMMAND_NAME+4]
			jnz @2			

			mov	eax,offset XML_XMLCommandProc
			mov	[esi-XMLParser.charParserEFSM].lpCommand,eax
			jmp @3
@2:
			mov	eax,[esi-XMLParser.charParserEFSM].lpCommandHandler
			or	eax,eax
			jz @3

			push	[esi-XMLParser.charParserEFSM].lpAuxString
			call DWORD PTR eax
		; return value is a pointer to the Command processor function or NULL
			mov	[esi-XMLParser.charParserEFSM].lpCommand,eax
@3:
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi
			clc

			ret
XML_CommandNameEnd	ENDP

; 
; eax - input character
XML_Command		PROC

			mov	edi,[esi-XMLParser.charParserEFSM].lpChar	; pointer in AuxString
			mov	[edi],ax					; store last input char

			mov	ebx,[esi-XMLParser.charParserEFSM].lpAuxString
			add	edi,2
			add	ebx,XML_AUX_STRING_SIZE
			cmp	edi,ebx					; end of AuxString reached?
			jc @1
				mov	eax,[esi-XMLParser.charParserEFSM].lpCommand
				or	eax,eax
				jz @2
				mov	ebx,[esi-XMLParser.charParserEFSM].lpAuxString
				mov	WORD PTR [edi-2],0
				mov	[esi-XMLParser.charParserEFSM].lpChar,ebx
				push	ebx
				call DWORD PTR eax			; pass the command string (part of it)
				cmp	eax,1
				jmp @2
@1:
			mov	[esi-XMLParser.charParserEFSM].lpChar,edi
			clc
@2:
			ret
XML_Command		ENDP
; 
XML_CommandEnd		PROC

			mov	edi,[esi-XMLParser.charParserEFSM].lpChar
			mov	WORD PTR [edi-2],0			; overwrite the last '?' with zero

			mov	eax,[esi-XMLParser.charParserEFSM].lpCommand
			or	eax,eax
			jz @1
			push	[esi-XMLParser.charParserEFSM].lpAuxString
			call DWORD PTR eax
			cmp	eax,1
@1:
			mov	[esi-XMLParser.charParserEFSM].lpCommand,NULL

			ret
XML_CommandEnd		ENDP
; 

			ASSUME esi:NOTHING