; 

CreateMain	PROC

		invoke GlobalAlloc,GPTR,BUFFER_SIZE
		mov	lpBuffer,eax

; Create the XML parser instance with StartTag,CDATA and CloseTag handler and no command handler
		invoke XML_createParser,offset MyStartTagHandler,offset MyCDATAHandler,offset MyEndTagHandler,NULL
		mov	MyXMLParser,eax

		xor	eax,eax

		ret
CreateMain	ENDP

; 

DestroyMain	PROC

; destroy the XML parser instance
		invoke XML_destroyParser,MyXMLParser
		invoke GlobalFree,lpBuffer
		
		ret
DestroyMain	ENDP

; 

CreateEditBox	PROC

		invoke GetClientRect,hMainWnd,addr Rect
		mov	eax,Rect.left
		sub	Rect.right,eax
		mov	eax,Rect.top
		sub	Rect.bottom,eax
		mov	eax,WS_VISIBLE or WS_CHILD or WS_VSCROLL or \
				ES_LEFT or ES_MULTILINE or ES_AUTOVSCROLL or \
				DS_LOCALEDIT
		invoke CreateWindowEx,NULL,
				addr szEditCtrlClass,NULL,
				eax,
				0,0,Rect.right,Rect.bottom,
				hMainWnd,ID_EDITBOX,
				hInstance,NULL
		or	eax,eax
		jnz @1
		mov	eax,offset szEditBoxError1
		jmp @2
@1:
		mov	hEditBox,eax
		invoke EnableWindow,hEditBox,FALSE
		invoke GetStockObject,SYSTEM_FIXED_FONT
		mov	hFnt,eax
		invoke SendMessage,hEditBox,WM_SETFONT,hFnt,TRUE		; set font
		xor	eax,eax
@2:
		ret
CreateEditBox	ENDP

; 

Open		PROC

		mov	ofn.lStructSize,sizeof OPENFILENAME
		mov	eax,hMainWnd
		mov	ofn.hWndOwner,eax
		mov	eax,hInstance
		mov	ofn.hInstance,eax
		mov	eax,offset fileFilter
		mov	ofn.lpstrFilter,eax
		mov	ofn.lpstrCustomFilter,NULL
		  mov	ofn.nMaxCustFilter,0
		mov	ofn.nFilterIndex,1
		mov	eax,offset szFileName
		mov	ofn.lpstrFile,eax
		mov	ofn.nMaxFile,260
		mov	ofn.lpstrFileTitle,NULL
		  mov	ofn.nMaxFileTitle,0
		mov	ofn.lpstrInitialDir,NULL
		mov	ofn.lpstrTitle,NULL
		mov	ofn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST  or OFN_LONGNAMES
		mov	ofn.lpstrDefExt,NULL
		invoke GetOpenFileName,offset ofn
		or	eax,eax
		jnz @1
		invoke CommDlgExtendedError
		mov	eax,1
		jz @3
		mov	eax,offset szFileError1
		jmp @3
@1:
		invoke CreateFile,addr szFileName,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		or	eax,eax
		jnz @2
		mov	eax,offset szFileError1
		jmp @3
@2:
		mov	hFile,eax
		xor	eax,eax
@3:
		ret
Open		ENDP

; 

ProcessFile	PROC

@1:
; Read a portion of the file into the buffer
		invoke ReadFile,hFile,lpBuffer,BUFFER_SIZE,addr dwBytesRead,NULL
		or	eax,eax
		jnz @11
		mov	eax,offset szFileError2
		jmp @3
@11:
		mov	eax,dwBytesRead
		or	eax,eax
		jz @3

@2:
; Parse the data in the buffer
		invoke XML_parse,MyXMLParser,lpBuffer,dwBytesRead
		or	eax,eax
		jnz @1

; On error get the error text
		invoke XML_error,MyXMLParser
; End
@3:
		ret
ProcessFile	ENDP

; 

TopXY		PROC wDim:DWORD, sDim:DWORD

		mov	eax,sDim
		sub	eax,wDim
		shr	eax,1
		
		ret
TopXY		ENDP

; 